#!/usr/bin/perl

#my $splash ;

#BEGIN {
#  require Angstd::Splash ;
#  $splash = Angstd::Splash->Show( '', 159, 165, 'Starting Angstd', 1 ) ;
#}

use strict;
use warnings ;
use Data::Dumper ;
use GraphEdit::GraphWindow ;

# --------------------------------------------------------
our $VERSION   = '22-April-2008';
our $RELEASE   = '4' ;
our $AUTHOR    = 'January Weiner <january@uni-muenster.de>' ;
# --------------------------------------------------------

# --------------------------------------------------------
# --------------------------------------------------------

# --------------------------------------------------------
#                    LICENSE
# --------------------------------------------------------
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# --------------------------------------------------------

# --------------------------------------------------------
use Config;
use File::Spec ;
use Getopt::Long;
use Time::HiRes qw( gettimeofday tv_interval );
use Data::Dumper ;
#use Compress::Zlib ;
use gv ;

use LWP::Simple ;


use Tk;
use Tk::Balloon     ;
use Tk::BrowseEntry ;
use Tk::Canvas      ;
use Tk::Clipboard   ;
use Tk::ColorEditor ;
use Tk::Dialog      ;
use Tk::FileSelect  ;
use Tk::Photo ;
use Tk::JPEG ;
use Tk::NoteBook    ;
use Tk::ProgressBar ;
#use Tk::Pod;
use Tk::X11Font     ;
#use Tk::DragDrop ;
#use Tk::DropSite;
#use Tk::Spectrum    ;
#use Tk::FontDialog  ;
#use Tk::ToolBar ;

#use Angstd::Annotation ;
#use Angstd::Annotator ;
#use Angstd::Configuration ;
#use Angstd::Configurator ;
#use Angstd::Domains ;
#use Angstd::Domdotplot ;
#use Angstd::Domdrawer ;
#use Angstd::Domgraph ;
#use Angstd::Editor ;
#use Angstd::Exporting ;
#use Angstd::Internet ;
#use Angstd::Legend ;
#use Angstd::Menufactory ;
#use Angstd::Parsers ;
#use Angstd::Userinfo ;
#use Angstd::Utilities ;
# only in development:
#use Devel::DProf ;

# --------------------------------------------------------

# --------------------------------------------------------
#           global variables
# --------------------------------------------------------
my %PARS;    # parameters
our $DEBUG = 1;                  # debuggin'?
my $DIG_LIMIT         = 5000;
# --------------------------------------------------------


# --------------------------------------------------------
#            some preset things
# --------------------------------------------------------
my $INSTALL_DIR = "./" ;
my $DOC_FILE    = "angstd.pl" ;
my $COL_FILE ;
my $LAB_FILE ;
my $HELP = 0 ;

GetOptions( 'help+' => \$HELP, 'color_file=s' => \$COL_FILE, 'label_file=s' => \$LAB_FILE ) ;
if( $HELP ) {
  show_help() ;
  exit 0 ;
}

$PARS{-mw} = MainWindow->new;
$PARS{-mw}->optionAdd('*BorderWidth' => 1 ) ;
$PARS{-mw}->optionAdd("*font", 'Arial 10', "userDefault");

my $ifile = $ARGV[0] ;
$PARS{-mw}->title( $ifile ) ;
if( $ifile ) { $PARS{-graph} = read_graph_dot( $ifile ) }

my $maingraph = GraphEdit::GraphWindow->new( %PARS ) ;
if( $COL_FILE ) { $maingraph->read_colors( $COL_FILE ) ; }
if( $LAB_FILE ) { $maingraph->read_labels( $LAB_FILE ) ; }

MainLoop() ;

exit 0 ;

sub read_graph {
  my ( $file ) = @_ ;

  my %nodes ;
  open( my $if, $file ) or die "Cannot read $file: $!\n" ;
  while( <$if> ) {
    chomp ;
    my ( $a, $b, $c ) = split /\s+/, $_ ;
    $nodes{$a} ||= { } ;  $nodes{$a}{$b} = $c || 1 ;
    $nodes{$b} ||= { } ;  $nodes{$b}{$a} = $c || 1 ;
  }

  print Dumper( \%nodes ) ;
  return \%nodes ;
}

sub read_graph_dot {
  my ( $file ) = @_ ;

  return gv::read( $file ) ;
}

sub show_help {
print <<EOF;
  $0 -- simple graph editor for dot files

  Usage: 
    $0 [options] [dotfile]

  Options:

    -h  
    --help    
           show this help
    -c file 
    --color_file=file
           read node colors from "file"
    -l file 
    --label_file=file
           read node labels from "file"
EOF

}
